<?php
#-----------------------------------------------------------------------
# display source of script if requested so
#-----------------------------------------------------------------------
if (isset($_REQUEST['sce']) && strtolower($_REQUEST['sce']) == 'view' ) {
   $filenameReal = __FILE__;
   $download_size = filesize($filenameReal);
   header('Pragma: public');
   header('Cache-Control: private');
   header('Cache-Control: no-cache, must-revalidate');
   header("Content-type: text/plain");
   header("Accept-Ranges: bytes");
   header("Content-Length: $download_size");
   header('Connection: close');
   readfile($filenameReal);
   exit;
}
$pageName	= 'wsMetarXml.php';
if (!isset($SITE)){echo "<h3>invalid call to script $pageName</h3>";exit;}
$pageVersion	= '3.01 2014-11-08';
$SITE['wsModules'][$pageName] = 'version: ' . $pageVersion;
$pageFile = basename(__FILE__);			// check to see this is the real script
if ($pageFile <> $pageName) {$SITE['wsModules'][$pageFile]	= 'this file loaded instead of '.$pageName;}
echo '<!-- module '.$pageFile.' ==== '.$SITE['wsModules'][$pageFile]." -->".PHP_EOL;
#-----------------------------------------------------------------------
# 3.00 2014-09-21 release version
# 3.01 2014-11-08 added other metar server because of problems with adds
# ----------------------------------------------------------------------
#  to do: document
#-----------------------------------------------------------------------------------------
$weatherApiUrl	= 'http://weather.aero/dataserver_current/httpparam?dataSource=metars&requestType=retrieve&format=xml&hoursBeforeNow=3&mostRecent=true&stationString='.$SITE['METAR'];
$weatherApiUrl	= 'http://aviationweather.gov/adds/dataserver_current/httpparam?dataSource=metars&requestType=retrieve&format=xml&hoursBeforeNow=2&stationString='.$SITE['METAR'];
$fileOK 	= false;
$cacheTime	= 900;				// seconds before file is to old
#
$string		= $pageFile.$SITE['METAR'];
$from		= '.';
$string		= str_replace ($from,'',$string	);
$cachedMetarFile= $SITE['cacheDir'].$string.'.txt';
#
if ( isset($_REQUEST['force']) && $_REQUEST['force'] == 'metar') 
        {$check_metar_cache = false;
        echo '<!-- Metardata cache checking is skipped as request for force was set to metar -->'.PHP_EOL;
        } 
else    {$check_metar_cache = true;}
#
if ( file_exists($cachedMetarFile) && $check_metar_cache) {
	$file_time	= filemtime($cachedMetarFile);
	$now		= time();
	$diff		= $now - $file_time;		
	if (isset ($wsDebug) && $wsDebug == true) {
		echo "<!-- Metardata ($cachedMetarFile) 
	cache time   = ".date('c',$file_time)." from unix time $file_time
	current time = ".date('c',$now)." from unix time $now 
	difference   = $diff (seconds)
	diff allowed = $cacheTime (seconds) -->".PHP_EOL;	
	}
	if ($diff <= $cacheTime){
		$rawData =  file_get_contents($cachedMetarFile);
		if (!$rawData  || check_errors ($rawData)) { 
		        echo "<!-- Metardata ($cachedMetarFile) could not be loaded from cache  -->".PHP_EOL;
		}
		elseif (check_errors ($rawData)) {
		        echo "<!-- Metardata ($cachedMetarFile) could not be loaded, contains errors  -->".PHP_EOL;
		}
		else {  echo "<!-- Metardata ($cachedMetarFile) loaded from cache  -->".PHP_EOL;		
		        $fileOK = true;
		}
	}
}	// eo check cache
if (!$fileOK) {
	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_URL, $weatherApiUrl);
	curl_setopt ($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 60);
	$rawData = curl_exec ($ch);
	curl_close ($ch);
	if (!$rawData || check_errors ($rawData)) {
		echo "<!-- weatherdata ($weatherApiUrl) could not be retrieved  from url -->".PHP_EOL;
	} 
	else {  if ($wsDebug) {echo '<!-- metarXml.php retrieving '.$weatherApiUrl.' -->'.PHP_EOL;}
		if (!file_put_contents($cachedMetarFile, $rawData)) {   
			echo PHP_EOL."<!-- Could not save xml data to cache ($cachedMetarFile). Please make sure your cache directory exists and is writable. -->".PHP_EOL;
		} 
		else {  echo "<!-- Weatherdata ($cachedMetarFile) saved to cache  -->".PHP_EOL;
		}  // eo cache
	}
}	// eo load new xml
#
$arrConditions 		= array();
#
if (check_errors ($rawData)) {
	$coverDescription 	= 'unknown Metar error';
	$iconNrPr		= 100;
	return;
} 
$xml    = new SimpleXMLElement($rawData);
if (!isset ($ws['myMetarVisib']) ) {$ws['myMetarVisib'] = 'unknown';}
if (isset ($xml->data->METAR->visibility_statute_mi)) {$ws['myMetarVisib'] = $xml->data->METAR->visibility_statute_mi;}
if ($wsDebug) {
	echo '<!-- '; print_r ($xml->data->METAR);echo ' --> '.PHP_EOL;
	echo '<!-- $ws["myMetarVisib"] = '.$ws['myMetarVisib'].' --> '.PHP_EOL;
#	echo '<!-- metarXml.php  raw input: '.$xml->data->METAR->raw_text.'     -->'.PHP_EOL;
}
# 									get the weather condition string
$string = (string)  $xml->data->METAR->wx_string;
if (strlen($string) > 1) {
	$arrConditions	= wsMetarConditions($string);
}
if ($wsDebug) {
	$end = count($arrConditions);
	for ($i = 0; $i < $end; $i++) {
		echo '<!-- metarXml.php weather conditions '.$i.' nr '.$arrConditions[$i]['nr'].' text '.$arrConditions[$i]['txt'].' -->'.PHP_EOL; 
	}
}
$end = count($xml->data->METAR->sky_condition);
$coverNumber 	= -1;
$description	= '';
# 'Partly Cloudy'
if ($end <> 0 ) {
	for ($i = 0; $i < $end; $i++){
		$string = $xml->data->METAR->sky_condition[$i]['sky_cover'];
		list ( $coverNumber, $coverDescription) = wsMetarCloudCover($string, $coverNumber, $description);
	}
} else {    // no sky condition field found
	$found = strpos($xml->data->METAR->raw_text,'NCD');
	if ($found <> false) {$coverNumber = 0;}
	$coverDescription	= 'Clear';
}
if ($wsDebug) {echo '<!-- metarXml.php clouds #:'.$coverNumber. ' description:'.$coverDescription.' -->'.PHP_EOL;}

$changed = false;
$end = count($arrConditions);
$iconPrecip	= 0;
$iconfog	= 0;
for ($i = 0; $i < $end; $i++) {
	$nr = $arrConditions[$i]['nr'];
	if ($nr >= 50 &&  $nr <= 52) {$iconfog		= $nr; continue;}
	if ($nr >= 10 &&  $nr <= 32) {$iconPrecip	= $nr; continue;}
}
#
if ($coverNumber == -1) 					{$coverNumber = 1; $changed = true;}
if ($iconPrecip <> 0 && $coverNumber == 0)	{$coverNumber = 1; $changed = true;}
if ($iconfog 	<> 0 && $coverNumber == 0)	{$coverNumber = 1; $changed = true;}
if ($wsDebug && $changed) {echo '<!-- metarXml.php clouds #:'.$coverNumber. ' description:'.$description.' -->'.PHP_EOL;}

$iconNrPr = 100 * $coverNumber + $iconPrecip;
$iconNrFo = 100 * $coverNumber + $iconfog;
if ($iconPrecip == 0) {$iconNrPr = $iconNrFo; $iconNrFo == 0;}
if ($iconNrPr == 0) {$iconNrPr = '000';}

if ($wsDebug) {echo '<!-- metarXml.php icon clouds = '.$coverNumber.' precip = '.$iconPrecip.' result = '.$iconNrPr.' - '.$iconNrFo.' -->'.PHP_EOL;}

function wsMetarConditions($conditions) {
global $wsDebug;
	// Decodes current weather conditions.
	// To learn more about weather condition codes, visit section 12.6.8 
	// Present Weather Group of the Federal Meteorological Handbook No. 1 at
	// www.nws.noaa.gov/oso/oso1/oso12/fmh1/fmh1ch12.htm

    if ($wsDebug) {echo  "<!-- wsMetarConditions = '$conditions' on entry -->".PHP_EOL;}
	$wxCode[1] = array(	
		'VC' => array('nr' => 0,	'txt' =>	'Nearby ')
		);
	$wxCode[2] = array(	
		'MI' => array('nr' => 0,	'txt' =>	'Shallow '),
		'PR' => array('nr' => 0,	'txt' =>	'Partial '),
		'BC' => array('nr' => 0,	'txt' =>	'Patches of '),
		'DR' => array('nr' => 0,	'txt' =>	'Low Drifting '),
		'BL' => array('nr' => 0,	'txt' =>	'Blowing '),
		'TS' => array('nr' => 0,	'txt' =>	'Thunderstorm'),
		'FZ' => array('nr' => 0,	'txt' =>	'Freezing ')
		);
	$wxCode[3] = array(		
		'DZ' => array('nr' => 10,	'txt' =>	'Drizzle'),
		'RA' => array('nr' => 10,	'txt' =>	'Rain'),
		'SN' => array('nr' => 20,	'txt' =>	'Snow'),
		'SG' => array('nr' => 20,	'txt' =>	'Snow Grains'),
		'IC' => array('nr' => 30,	'txt' =>	'Ice Crystals'),
		'PE' => array('nr' => 30,	'txt' =>	'Ice Pellets'),
		'GR' => array('nr' => 30,	'txt' =>	'Hail'),
		'GS' => array('nr' => 30,	'txt' =>	'Small Hail'),
		'PL' => array('nr' => 30,	'txt' =>	'Ice Pellets'),
		'UP' => array('nr' => 0,	'txt' =>	'')
		);   			
	$wxCode[4] = array(	
		'SH' => array('nr' => 0,	'txt' =>	'Showers')
		);
	$wxCode[5] = array(		
		'BR' => array('nr' => 50,	'txt' =>	'Mist'),
		'FG' => array('nr' => 0,	'txt' =>	'Fog'),
		'FU' => array('nr' => 0,	'txt' =>	'Smoke'),
		'VA' => array('nr' => 0,	'txt' =>	'Volcanic Ash'),
		'DU' => array('nr' => 0,	'txt' =>	'Widespread Dust'),
		'SA' => array('nr' => 0,	'txt' =>	'Sand'),
		'HZ' => array('nr' => 50,	'txt' =>	'Haze'),
		'PY' => array('nr' => 0,	'txt' =>	'Spray')
		);
	$wxCode[6] = array(		
		'PO' => array('nr' => 0,   'txt' =>	'Well-developed Dust/Sand Whirls'),
		'SQ' => array('nr' => 0,   'txt' =>	'Squalls'),
		'FC' => array('nr' => 0,   'txt' =>	'Funnel Cloud, Tornado, or Waterspout'),
		'SS' => array('nr' => 0,   'txt' =>	'Sandstorm/Duststorm')
		);
	$arrConditions	= explode (' ', $conditions);
	$end 			= count ($arrConditions);
	for ($i = 0; $i < $end; $i++) {
		$words 	= array();
		$part 	= $arrConditions[$i];
	    if ($wsDebug) {echo   "<!-- wsMetarConditions part = '$part' -->".PHP_EOL;}
	    $pos1	= substr($part,0,1);
	    $digit		= 1;
		switch ( $pos1 ) {
			case '-':
				$words[1]	= 'Light';
				$digit		= 0;
				$part 		= substr($part,1);
				break;
			case '+':
				$words[1]	= 'Heavy';
				$digit		= 2;
				$part = substr($part,1);
				break;
			case 'V':
				$words[7]	= 'Nearby';
				$part = substr($part,2);
				break;
			default:
				$prefix = '';
		}  // eo switch
		$pos2 	= substr($part,0,2);
		$tenDigit = 0;
		for ($n = 2; $n <= 6; $n++) {
			if (strlen($part) < 2){
				break;}
			if (isset($wxCode[$n][$pos2]) ){
				$arr = $wxCode[$n][$pos2];
				$words[$n]	= $arr['txt'];
				if ($arr['nr'] > $tenDigit) {$tenDigit	= $arr['nr'];}
				$part 		= substr($part,2);
				$pos2 		= substr($part,0,2);
				$n = 2;
			}  // eo found in array
		}  // scan in all arrays
		// now combine all wordsa to one phrase
		$sentence = '';
		for ($n = 1; $n <= 7; $n++) {
			if (isset ($words[$n]) ) {
				$sentence .= $words[$n].' ';
			}
		}
		if ($wsDebug) {echo   "<!-- wsMetarConditions translation = '$sentence' -->".PHP_EOL;}
		$CCNarr[$i]['txt'] = trim($sentence);
		if ($tenDigit == 0) {$digit = 0;}
		$CCNarr[$i]['nr'] = trim($tenDigit) + $digit;				
	} // eo for every weather type
	return $CCNarr;
}
function wsMetarCloudCover($skycoverIn, $resultCover, $description) {
	global $wsDebug;
	$wxCloudCode = array(		// 0/8 cover
        'NC'	=> 0,
		'SK'	=> 0,
		'CL'	=> 0,
		'CA'	=> 0,			// CAVOK Ceiling And Visibility OKay,		
		'FE'	=> 1,			// 1/8 - 2/8
		'FW'	=> 1,   		// should not be there official code = FEW	
		'SC' 	=> 2,			// 3/8 - 4/8
		'NS' 	=> 2,
		'BK' 	=> 3,			// 5/8 - 7/8					
		'OV' 	=> 4,			// 8/8	
		'VV'  	=> 4);
	$wxCloudDescription = array('Clear', 'Few Clouds', 'Partly Cloudy', 'Mostly Cloudy', 'Overcast');		
#		'TCU' => 'Thunderstorm',
#		'CB'  => 'Thunderstorm',

	if ($wsDebug) {
		echo  "<!-- wsMetarCloudCover = '$skycoverIn' - '$resultCover' - '$description' on entry -->".PHP_EOL;
	}
	$pos2 	= substr($skycoverIn,0,2);
	$resultCover	= 0;
	$description	= '';
	if (!isset($wxCloudCode[$pos2]) ) {
		echo   "<!-- wsMetarCloudCover unknown cover code = '$skycoverIn' on entry -->".PHP_EOL;
	} else {
		$number = $wxCloudCode[$pos2];
		if ($wsDebug) {echo   "<!-- wsMetarConditions found = '$number' -->".PHP_EOL;}
		if ($number >= $resultCover) {
			$resultCover = $number;
			$description = $wxCloudDescription[$resultCover];			
		}  // more clouds detected		
	}  // cloud description found
	if ($wsDebug) {echo   "<!-- wsMetarConditions returned = '$resultCover' - '$description' -->".PHP_EOL;}
	return array($resultCover, $description);
}
function check_errors ($rawData) {
        $errorLength    = 300;  // 226 = length of 404 error
        if (strlen($rawData) <= $errorLength)  {return true;}
        $errors = array ('<title>404 Not Found</title>');
        $count  = count($errors);
        for ($n = 0; $n < $count; $n++) {
                $pos = strpos ($rawData,'<title>404 Not Found</title>');
                if ($pos > 2) {return true;}
        }
        return false;
}
?>